section .text$3 code align=16
global _yepCore_DotProduct_V32fV32f_S32f_Nehalem
_yepCore_DotProduct_V32fV32f_S32f_Nehalem:
	.ENTRY:
	XORPS xmm4, xmm4                                                       ; r8, r9, rcx, rdx, rsp
	XORPS xmm5, xmm5                                                       ; r8, r9, rcx, rdx, rsp, xmm4
	XORPS xmm3, xmm3                                                       ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	XORPS xmm2, xmm2                                                       ; r8, r9, rcx, rdx, rsp, xmm3, xmm4, xmm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	MOVSS xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULSS xmm1, [rdx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDSS xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	MOVUPS xmm1, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPS xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPS xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPS xmm1, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPS xmm1, [byte rcx + 32]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPS xmm5, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPS xmm1, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPS xmm1, [byte rcx + 64]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPS xmm3, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPS xmm1, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPS xmm1, [byte rcx + 96]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPS xmm2, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 32                                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 32                                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.process_single:
	MOVSS xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULSS xmm1, [rdx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDSS xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.reduce:
	ADDPS xmm4, xmm5                                                       ; r8, rsp, xmm2, xmm3, xmm4, xmm5
	ADDPS xmm3, xmm2                                                       ; r8, rsp, xmm2, xmm3, xmm4
	ADDPS xmm4, xmm3                                                       ; r8, rsp, xmm3, xmm4
	HADDPS xmm4, xmm4                                                      ; r8, rsp, xmm4
	HADDPS xmm4, xmm4                                                      ; r8, rsp, xmm4
	MOVSS [r8], xmm4                                                       ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_DotProduct_V32fV32f_S32f_SandyBridge
_yepCore_DotProduct_V32fV32f_S32f_SandyBridge:
	.ENTRY:
	VXORPS xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPS xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, ymm4
	VXORPS xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, ymm4, ymm5
	VXORPS xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, ymm3, ymm4, ymm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_misaligned:
	VMOVSS xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULSS xmm1, xmm1, [rdx]                                               ; r8, r9, rcx, rdx, rsp, xmm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_aligned:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	align 16
	.process_batch:
	VMOVUPS ymm1, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPS ymm1, ymm1, [rcx]                                               ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPS ymm1, ymm1, [byte rcx + 32]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm5, ymm5, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPS ymm1, ymm1, [byte rcx + 64]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm3, ymm3, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPS ymm1, ymm1, [byte rcx + 96]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm2, ymm2, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 64                                                            ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 64                                                            ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_single:
	VMOVSS xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULSS xmm1, xmm1, [rdx]                                               ; r8, r9, rcx, rdx, rsp, xmm1, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.reduce:
	VADDPS ymm4, ymm4, ymm5                                                ; r8, rsp, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm3, ymm3, ymm2                                                ; r8, rsp, ymm2, ymm3, ymm4
	VADDPS ymm4, ymm4, ymm3                                                ; r8, rsp, ymm3, ymm4
	VEXTRACTF128 xmm5, ymm4, 1                                             ; r8, rsp, ymm4
	VADDPS xmm4, xmm4, xmm5                                                ; r8, rsp, xmm4, xmm5
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VMOVSS [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$6 code align=16
global _yepCore_DotProduct_V32fV32f_S32f_Haswell
_yepCore_DotProduct_V32fV32f_S32f_Haswell:
	.ENTRY:
	VXORPS xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPS xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, ymm4
	VXORPS xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, ymm4, ymm5
	VXORPS xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, ymm3, ymm4, ymm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_misaligned:
	VMOVSS xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMOVSS xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm4, ymm1, ymm0                                           ; r8, r9, rcx, rdx, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_aligned:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	align 16
	.process_batch:
	VMOVUPS ymm1, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm4, ymm1, [rcx]                                          ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm5, ymm1, [byte rcx + 32]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm3, ymm1, [byte rcx + 64]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPS ymm1, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm2, ymm1, [byte rcx + 96]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 64                                                            ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 64                                                            ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_single:
	VMOVSS xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMOVSS xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VFMADD231PS ymm4, ymm1, ymm0                                           ; r8, r9, rcx, rdx, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.reduce:
	VADDPS ymm4, ymm4, ymm5                                                ; r8, rsp, ymm2, ymm3, ymm4, ymm5
	VADDPS ymm3, ymm3, ymm2                                                ; r8, rsp, ymm2, ymm3, ymm4
	VADDPS ymm4, ymm4, ymm3                                                ; r8, rsp, ymm3, ymm4
	VEXTRACTF128 xmm5, ymm4, 1                                             ; r8, rsp, ymm4
	VADDPS xmm4, xmm4, xmm5                                                ; r8, rsp, xmm4, xmm5
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VMOVSS [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$11 code align=16
global _yepCore_DotProduct_V32fV32f_S32f_Bulldozer
_yepCore_DotProduct_V32fV32f_S32f_Bulldozer:
	.ENTRY:
	SUB rsp, 24                                                            ; 
	VMOVAPS [rsp], xmm6                                                    ; 
	VXORPS xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPS xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, xmm4
	VXORPS xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	VXORPS xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, xmm3, xmm4, xmm5
	VXORPS xmm1, xmm1, xmm1                                                ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	VXORPS xmm0, xmm0, xmm0                                                ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	VMOVSS xmm6, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSS xmm4, xmm6, [rdx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	VMOVUPS xmm6, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm4, xmm6, [rcx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm5, xmm6, [byte rcx + 32], xmm5                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm3, xmm6, [byte rcx + 64], xmm3                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm2, xmm6, [byte rcx + 96], xmm2                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [dword rdx + 128]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm1, xmm6, [dword rcx + 128], xmm1                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [dword rdx + 160]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm0, xmm6, [dword rcx + 160], xmm0                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 48                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_single:
	VMOVSS xmm6, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSS xmm4, xmm6, [rdx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 4                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.reduce:
	VADDPS xmm4, xmm4, xmm5                                                ; r8, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VADDPS xmm3, xmm3, xmm2                                                ; r8, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPS xmm1, xmm1, xmm0                                                ; r8, rsp, xmm0, xmm1, xmm3, xmm4
	VADDPS xmm4, xmm4, xmm3                                                ; r8, rsp, xmm1, xmm3, xmm4
	VADDPS xmm4, xmm4, xmm1                                                ; r8, rsp, xmm1, xmm4
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VHADDPS xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VMOVSS [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	VMOVAPS xmm6, [rsp]                                                    ; 
	ADD rsp, 24                                                            ; 
	RET                                                                    ; rsp

section .text$3 code align=16
global _yepCore_DotProduct_V64fV64f_S64f_Nehalem
_yepCore_DotProduct_V64fV64f_S64f_Nehalem:
	.ENTRY:
	XORPD xmm4, xmm4                                                       ; r8, r9, rcx, rdx, rsp
	XORPD xmm5, xmm5                                                       ; r8, r9, rcx, rdx, rsp, xmm4
	XORPD xmm3, xmm3                                                       ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	XORPD xmm2, xmm2                                                       ; r8, r9, rcx, rdx, rsp, xmm3, xmm4, xmm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	MOVSD xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULSD xmm1, [rdx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDSD xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	MOVUPD xmm1, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPD xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPD xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPD xmm1, [byte rdx + 32]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPD xmm1, [byte rcx + 32]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPD xmm5, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPD xmm1, [byte rdx + 64]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPD xmm1, [byte rcx + 64]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPD xmm3, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	MOVUPD xmm1, [byte rdx + 96]                                           ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULPD xmm1, [byte rcx + 96]                                            ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDPD xmm2, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 64                                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 64                                                            ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD r9, 8                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.process_single:
	MOVSD xmm1, [rcx]                                                      ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	MULSD xmm1, [rdx]                                                      ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADDSD xmm4, xmm1                                                       ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	.reduce:
	ADDPD xmm4, xmm5                                                       ; r8, rsp, xmm2, xmm3, xmm4, xmm5
	ADDPD xmm3, xmm2                                                       ; r8, rsp, xmm2, xmm3, xmm4
	ADDPD xmm4, xmm3                                                       ; r8, rsp, xmm3, xmm4
	HADDPD xmm4, xmm4                                                      ; r8, rsp, xmm4
	MOVSD [r8], xmm4                                                       ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$4 code align=16
global _yepCore_DotProduct_V64fV64f_S64f_SandyBridge
_yepCore_DotProduct_V64fV64f_S64f_SandyBridge:
	.ENTRY:
	VXORPD xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPD xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, ymm4
	VXORPD xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, ymm4, ymm5
	VXORPD xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, ymm3, ymm4, ymm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_misaligned:
	VMOVSD xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULSD xmm1, xmm1, [rdx]                                               ; r8, r9, rcx, rdx, rsp, xmm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_aligned:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	align 16
	.process_batch:
	VMOVUPD ymm1, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPD ymm1, ymm1, [rcx]                                               ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPD ymm1, ymm1, [byte rcx + 32]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm5, ymm5, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPD ymm1, ymm1, [byte rcx + 64]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm3, ymm3, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULPD ymm1, ymm1, [byte rcx + 96]                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm2, ymm2, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 128                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 128                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_single:
	VMOVSD xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMULSD xmm1, xmm1, [rdx]                                               ; r8, r9, rcx, rdx, rsp, xmm1, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm4, ymm4, ymm1                                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.reduce:
	VADDPD ymm4, ymm4, ymm5                                                ; r8, rsp, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm3, ymm3, ymm2                                                ; r8, rsp, ymm2, ymm3, ymm4
	VADDPD ymm4, ymm4, ymm3                                                ; r8, rsp, ymm3, ymm4
	VEXTRACTF128 xmm5, ymm4, 1                                             ; r8, rsp, ymm4
	VADDPD xmm4, xmm4, xmm5                                                ; r8, rsp, xmm4, xmm5
	VHADDPD xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VMOVSD [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$6 code align=16
global _yepCore_DotProduct_V64fV64f_S64f_Haswell
_yepCore_DotProduct_V64fV64f_S64f_Haswell:
	.ENTRY:
	VXORPD xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPD xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, ymm4
	VXORPD xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, ymm4, ymm5
	VXORPD xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, ymm3, ymm4, ymm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_misaligned:
	VMOVSD xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMOVSD xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm4, ymm1, ymm0                                           ; r8, r9, rcx, rdx, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	TEST rcx, 31                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.source_32b_aligned:
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	align 16
	.process_batch:
	VMOVUPD ymm1, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm4, ymm1, [rcx]                                          ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm5, ymm1, [byte rcx + 32]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm3, ymm1, [byte rcx + 64]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VMOVUPD ymm1, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm2, ymm1, [byte rcx + 96]                                ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 128                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 128                                                           ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_restore:
	ADD r9, 16                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.process_single:
	VMOVSD xmm1, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	VMOVSD xmm0, [rdx]                                                     ; r8, r9, rcx, rdx, rsp, ymm1, ymm2, ymm3, ymm4, ymm5
	VFMADD231PD ymm4, ymm1, ymm0                                           ; r8, r9, rcx, rdx, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, ymm2, ymm3, ymm4, ymm5
	.reduce:
	VADDPD ymm4, ymm4, ymm5                                                ; r8, rsp, ymm2, ymm3, ymm4, ymm5
	VADDPD ymm3, ymm3, ymm2                                                ; r8, rsp, ymm2, ymm3, ymm4
	VADDPD ymm4, ymm4, ymm3                                                ; r8, rsp, ymm3, ymm4
	VEXTRACTF128 xmm5, ymm4, 1                                             ; r8, rsp, ymm4
	VADDPD xmm4, xmm4, xmm5                                                ; r8, rsp, xmm4, xmm5
	VHADDPD xmm4, xmm4, xmm4                                               ; r8, rsp, xmm4
	VMOVSD [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text$11 code align=16
global _yepCore_DotProduct_V64fV64f_S64f_Bulldozer
_yepCore_DotProduct_V64fV64f_S64f_Bulldozer:
	.ENTRY:
	SUB rsp, 24                                                            ; 
	VMOVAPS [rsp], xmm6                                                    ; 
	VXORPD xmm4, xmm4, xmm4                                                ; r8, r9, rcx, rdx, rsp
	VXORPD xmm5, xmm5, xmm5                                                ; r8, r9, rcx, rdx, rsp, xmm4
	VXORPD xmm3, xmm3, xmm3                                                ; r8, r9, rcx, rdx, rsp, xmm4, xmm5
	VXORPD xmm2, xmm2, xmm2                                                ; r8, r9, rcx, rdx, rsp, xmm3, xmm4, xmm5
	VXORPD xmm1, xmm1, xmm1                                                ; r8, r9, rcx, rdx, rsp, xmm2, xmm3, xmm4, xmm5
	VXORPD xmm0, xmm0, xmm0                                                ; r8, r9, rcx, rdx, rsp, xmm1, xmm2, xmm3, xmm4, xmm5
	CMP r9, 0                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	VMOVSD xmm6, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSD xmm4, xmm6, [rdx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rcx, 15                                                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	VMOVUPD xmm6, [rdx]                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm4, xmm6, [rcx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rdx + 32]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm5, xmm6, [byte rcx + 32], xmm5                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rdx + 64]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm3, xmm6, [byte rcx + 64], xmm3                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rdx + 96]                                          ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm2, xmm6, [byte rcx + 96], xmm2                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [dword rdx + 128]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm1, xmm6, [dword rcx + 128], xmm1                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [dword rdx + 160]                                        ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm0, xmm6, [dword rcx + 160], xmm0                           ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 96                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 96                                                            ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD r9, 12                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_single:
	VMOVSD xmm6, [rcx]                                                     ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSD xmm4, xmm6, [rdx], xmm4                                       ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rcx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rdx, 8                                                             ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB r9, 1                                                              ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; r8, r9, rcx, rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.reduce:
	VADDPD xmm4, xmm4, xmm5                                                ; r8, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VADDPD xmm3, xmm3, xmm2                                                ; r8, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	VADDPD xmm1, xmm1, xmm0                                                ; r8, rsp, xmm0, xmm1, xmm3, xmm4
	VADDPD xmm4, xmm4, xmm3                                                ; r8, rsp, xmm1, xmm3, xmm4
	VADDPD xmm4, xmm4, xmm1                                                ; r8, rsp, xmm1, xmm4
	VUNPCKHPD xmm5, xmm4, xmm4                                             ; r8, rsp, xmm4
	VADDSD xmm4, xmm4, xmm5                                                ; r8, rsp, xmm4, xmm5
	VMOVSD [r8], xmm4                                                      ; r8, rsp, xmm4
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	VMOVAPS xmm6, [rsp]                                                    ; 
	ADD rsp, 24                                                            ; 
	RET                                                                    ; rsp
