section .text.Nehalem progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V32fV32f_S32f_Nehalem
_yepCore_DotProduct_V32fV32f_S32f_Nehalem:
	.ENTRY:
	XORPS xmm0, xmm0                                                       ; rcx, rdi, rdx, rsi, rsp
	XORPS xmm1, xmm1                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0
	XORPS xmm2, xmm2                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1
	XORPS xmm3, xmm3                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.source_32b_misaligned:
	MOVSS xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULSS xmm4, [rsi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDSS xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.source_32b_aligned:
	SUB rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	align 16
	.process_batch:
	MOVUPS xmm4, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPS xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPS xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPS xmm4, [byte rsi + 32]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPS xmm4, [byte rdi + 32]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPS xmm1, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPS xmm4, [byte rsi + 64]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPS xmm4, [byte rdi + 64]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPS xmm2, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPS xmm4, [byte rsi + 96]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPS xmm4, [byte rdi + 96]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPS xmm3, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 32                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 32                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.process_restore:
	ADD rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.process_single:
	MOVSS xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULSS xmm4, [rsi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDSS xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.reduce:
	ADDPS xmm0, xmm1                                                       ; rdx, rsp, xmm0, xmm1, xmm2, xmm3
	ADDPS xmm2, xmm3                                                       ; rdx, rsp, xmm0, xmm2, xmm3
	ADDPS xmm0, xmm2                                                       ; rdx, rsp, xmm0, xmm2
	HADDPS xmm0, xmm0                                                      ; rdx, rsp, xmm0
	HADDPS xmm0, xmm0                                                      ; rdx, rsp, xmm0
	MOVSS [rdx], xmm0                                                      ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.SandyBridge progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V32fV32f_S32f_SandyBridge
_yepCore_DotProduct_V32fV32f_S32f_SandyBridge:
	.ENTRY:
	VXORPS xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPS xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, ymm0
	VXORPS xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1
	VXORPS xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_misaligned:
	VMOVSS xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULSS xmm4, xmm4, [rsi]                                               ; rcx, rdi, rdx, rsi, rsp, xmm4, ymm0, ymm1, ymm2, ymm3
	VADDPS ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_aligned:
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	align 16
	.process_batch:
	VMOVUPS ymm4, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPS ymm4, ymm4, [rdi]                                               ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPS ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPS ymm4, ymm4, [byte rdi + 32]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPS ymm1, ymm1, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPS ymm4, ymm4, [byte rdi + 64]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPS ymm2, ymm2, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPS ymm4, ymm4, [byte rdi + 96]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPS ymm3, ymm3, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_restore:
	ADD rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_single:
	VMOVSS xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULSS xmm4, xmm4, [rsi]                                               ; rcx, rdi, rdx, rsi, rsp, xmm4, ymm0, ymm1, ymm2, ymm3
	VADDPS ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.reduce:
	VADDPS ymm0, ymm0, ymm1                                                ; rdx, rsp, ymm0, ymm1, ymm2, ymm3
	VADDPS ymm2, ymm2, ymm3                                                ; rdx, rsp, ymm0, ymm2, ymm3
	VADDPS ymm0, ymm0, ymm2                                                ; rdx, rsp, ymm0, ymm2
	VEXTRACTF128 xmm1, ymm0, 1                                             ; rdx, rsp, ymm0
	VADDPS xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VMOVSS [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.Haswell progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V32fV32f_S32f_Haswell
_yepCore_DotProduct_V32fV32f_S32f_Haswell:
	.ENTRY:
	VXORPS xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPS xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, ymm0
	VXORPS xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1
	VXORPS xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_misaligned:
	VMOVSS xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMOVSS xmm5, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VFMADD231PS ymm0, ymm4, ymm5                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_aligned:
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	align 16
	.process_batch:
	VMOVUPS ymm4, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PS ymm0, ymm4, [rdi]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PS ymm1, ymm4, [byte rdi + 32]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PS ymm2, ymm4, [byte rdi + 64]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPS ymm4, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PS ymm3, ymm4, [byte rdi + 96]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_restore:
	ADD rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_single:
	VMOVSS xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMOVSS xmm5, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VFMADD231PS ymm0, ymm4, ymm5                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.reduce:
	VADDPS ymm0, ymm0, ymm1                                                ; rdx, rsp, ymm0, ymm1, ymm2, ymm3
	VADDPS ymm2, ymm2, ymm3                                                ; rdx, rsp, ymm0, ymm2, ymm3
	VADDPS ymm0, ymm0, ymm2                                                ; rdx, rsp, ymm0, ymm2
	VEXTRACTF128 xmm1, ymm0, 1                                             ; rdx, rsp, ymm0
	VADDPS xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VMOVSS [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.Bulldozer progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V32fV32f_S32f_Bulldozer
_yepCore_DotProduct_V32fV32f_S32f_Bulldozer:
	.ENTRY:
	VXORPS xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPS xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, xmm0
	VXORPS xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1
	VXORPS xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2
	VXORPS xmm4, xmm4, xmm4                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	VXORPS xmm5, xmm5, xmm5                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	VMOVSS xmm6, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSS xmm0, xmm6, [rsi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	VMOVUPS xmm6, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm0, xmm6, [rdi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm1, xmm6, [byte rdi + 32], xmm1                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm2, xmm6, [byte rdi + 64], xmm2                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm3, xmm6, [byte rdi + 96], xmm3                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [dword rsi + 128]                                        ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm4, xmm6, [dword rdi + 128], xmm4                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPS xmm6, [dword rsi + 160]                                        ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPS xmm5, xmm6, [dword rdi + 160], xmm5                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 48                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 48                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_single:
	VMOVSS xmm6, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSS xmm0, xmm6, [rsi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 4                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.reduce:
	VADDPS xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VADDPS xmm2, xmm2, xmm3                                                ; rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5
	VADDPS xmm4, xmm4, xmm5                                                ; rdx, rsp, xmm0, xmm2, xmm4, xmm5
	VADDPS xmm0, xmm0, xmm2                                                ; rdx, rsp, xmm0, xmm2, xmm4
	VADDPS xmm0, xmm0, xmm4                                                ; rdx, rsp, xmm0, xmm4
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VHADDPS xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VMOVSS [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.Nehalem progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V64fV64f_S64f_Nehalem
_yepCore_DotProduct_V64fV64f_S64f_Nehalem:
	.ENTRY:
	XORPD xmm0, xmm0                                                       ; rcx, rdi, rdx, rsi, rsp
	XORPD xmm1, xmm1                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0
	XORPD xmm2, xmm2                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1
	XORPD xmm3, xmm3                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.source_32b_misaligned:
	MOVSD xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULSD xmm4, [rsi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDSD xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.source_32b_aligned:
	SUB rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	align 16
	.process_batch:
	MOVUPD xmm4, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPD xmm4, [byte rsi + 32]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm4, [byte rdi + 32]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm1, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPD xmm4, [byte rsi + 64]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm4, [byte rdi + 64]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm2, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	MOVUPD xmm4, [byte rsi + 96]                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULPD xmm4, [byte rdi + 96]                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDPD xmm3, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 64                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.process_restore:
	ADD rcx, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.process_single:
	MOVSD xmm4, [rdi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	MULSD xmm4, [rsi]                                                      ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADDSD xmm0, xmm4                                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	.reduce:
	ADDPD xmm0, xmm1                                                       ; rdx, rsp, xmm0, xmm1, xmm2, xmm3
	ADDPD xmm2, xmm3                                                       ; rdx, rsp, xmm0, xmm2, xmm3
	ADDPD xmm0, xmm2                                                       ; rdx, rsp, xmm0, xmm2
	HADDPD xmm0, xmm0                                                      ; rdx, rsp, xmm0
	MOVSD [rdx], xmm0                                                      ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.SandyBridge progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V64fV64f_S64f_SandyBridge
_yepCore_DotProduct_V64fV64f_S64f_SandyBridge:
	.ENTRY:
	VXORPD xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPD xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, ymm0
	VXORPD xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1
	VXORPD xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_misaligned:
	VMOVSD xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULSD xmm4, xmm4, [rsi]                                               ; rcx, rdi, rdx, rsi, rsp, xmm4, ymm0, ymm1, ymm2, ymm3
	VADDPD ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_aligned:
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	align 16
	.process_batch:
	VMOVUPD ymm4, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPD ymm4, ymm4, [rdi]                                               ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPD ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPD ymm4, ymm4, [byte rdi + 32]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPD ymm1, ymm1, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPD ymm4, ymm4, [byte rdi + 64]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPD ymm2, ymm2, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULPD ymm4, ymm4, [byte rdi + 96]                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VADDPD ymm3, ymm3, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 128                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 128                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_restore:
	ADD rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_single:
	VMOVSD xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMULSD xmm4, xmm4, [rsi]                                               ; rcx, rdi, rdx, rsi, rsp, xmm4, ymm0, ymm1, ymm2, ymm3
	VADDPD ymm0, ymm0, ymm4                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.reduce:
	VADDPD ymm0, ymm0, ymm1                                                ; rdx, rsp, ymm0, ymm1, ymm2, ymm3
	VADDPD ymm2, ymm2, ymm3                                                ; rdx, rsp, ymm0, ymm2, ymm3
	VADDPD ymm0, ymm0, ymm2                                                ; rdx, rsp, ymm0, ymm2
	VEXTRACTF128 xmm1, ymm0, 1                                             ; rdx, rsp, ymm0
	VADDPD xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1
	VHADDPD xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VMOVSD [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.Haswell progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V64fV64f_S64f_Haswell
_yepCore_DotProduct_V64fV64f_S64f_Haswell:
	.ENTRY:
	VXORPD xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPD xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, ymm0
	VXORPD xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1
	VXORPD xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_misaligned:
	VMOVSD xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMOVSD xmm5, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VFMADD231PD ymm0, ymm4, ymm5                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	TEST rdi, 31                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.source_32b_aligned:
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	align 16
	.process_batch:
	VMOVUPD ymm4, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PD ymm0, ymm4, [rdi]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PD ymm1, ymm4, [byte rdi + 32]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PD ymm2, ymm4, [byte rdi + 64]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VMOVUPD ymm4, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VFMADD231PD ymm3, ymm4, [byte rdi + 96]                                ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	ADD rdi, 128                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 128                                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_restore:
	ADD rcx, 16                                                            ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.process_single:
	VMOVSD xmm4, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	VMOVSD xmm5, [rsi]                                                     ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4
	VFMADD231PD ymm0, ymm4, ymm5                                           ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3, ymm4, ymm5
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, ymm0, ymm1, ymm2, ymm3
	.reduce:
	VADDPD ymm0, ymm0, ymm1                                                ; rdx, rsp, ymm0, ymm1, ymm2, ymm3
	VADDPD ymm2, ymm2, ymm3                                                ; rdx, rsp, ymm0, ymm2, ymm3
	VADDPD ymm0, ymm0, ymm2                                                ; rdx, rsp, ymm0, ymm2
	VEXTRACTF128 xmm1, ymm0, 1                                             ; rdx, rsp, ymm0
	VADDPD xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1
	VHADDPD xmm0, xmm0, xmm0                                               ; rdx, rsp, xmm0
	VMOVSD [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp

section .text.Bulldozer progbits alloc exec nowrite align=16
global _yepCore_DotProduct_V64fV64f_S64f_Bulldozer
_yepCore_DotProduct_V64fV64f_S64f_Bulldozer:
	.ENTRY:
	VXORPD xmm0, xmm0, xmm0                                                ; rcx, rdi, rdx, rsi, rsp
	VXORPD xmm1, xmm1, xmm1                                                ; rcx, rdi, rdx, rsi, rsp, xmm0
	VXORPD xmm2, xmm2, xmm2                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1
	VXORPD xmm3, xmm3, xmm3                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2
	VXORPD xmm4, xmm4, xmm4                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3
	VXORPD xmm5, xmm5, xmm5                                                ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4
	CMP rcx, 0                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JE .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .source_32b_aligned                                                 ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_misaligned:
	VMOVSD xmm6, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSD xmm0, xmm6, [rsi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .return_ok                                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	TEST rdi, 15                                                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .source_32b_misaligned                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.source_32b_aligned:
	SUB rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JB .process_restore                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	align 16
	.process_batch:
	VMOVUPD xmm6, [rsi]                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm0, xmm6, [rdi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rsi + 32]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm1, xmm6, [byte rdi + 32], xmm1                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rsi + 64]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm2, xmm6, [byte rdi + 64], xmm2                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [byte rsi + 96]                                          ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm3, xmm6, [byte rdi + 96], xmm3                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [dword rsi + 128]                                        ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm4, xmm6, [dword rdi + 128], xmm4                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	VMOVUPD xmm6, [dword rsi + 160]                                        ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDPD xmm5, xmm6, [dword rdi + 160], xmm5                           ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 96                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 96                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JAE .process_batch                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_restore:
	ADD rcx, 12                                                            ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JZ .reduce                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.process_single:
	VMOVSD xmm6, [rdi]                                                     ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VFMADDSD xmm0, xmm6, [rsi], xmm0                                       ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5, xmm6
	ADD rdi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	ADD rsi, 8                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	SUB rcx, 1                                                             ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	JNZ .process_single                                                    ; rcx, rdi, rdx, rsi, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	.reduce:
	VADDPD xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1, xmm2, xmm3, xmm4, xmm5
	VADDPD xmm2, xmm2, xmm3                                                ; rdx, rsp, xmm0, xmm2, xmm3, xmm4, xmm5
	VADDPD xmm4, xmm4, xmm5                                                ; rdx, rsp, xmm0, xmm2, xmm4, xmm5
	VADDPD xmm0, xmm0, xmm2                                                ; rdx, rsp, xmm0, xmm2, xmm4
	VADDPD xmm0, xmm0, xmm4                                                ; rdx, rsp, xmm0, xmm4
	VUNPCKHPD xmm1, xmm0, xmm0                                             ; rdx, rsp, xmm0
	VADDSD xmm0, xmm0, xmm1                                                ; rdx, rsp, xmm0, xmm1
	VMOVSD [rdx], xmm0                                                     ; rdx, rsp, xmm0
	.return_ok:
	XOR eax, eax                                                           ; rsp
	.return:
	RET                                                                    ; rsp
