/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <yepIntrinsics.h>
#include <yepCore.h>


extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V8uV8u_V8u_Default(const Yep8u* YEP_RESTRICT xPointer, const Yep8u* YEP_RESTRICT yPointer, Yep8u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep8u x = *xPointer++;
		const Yep8u y = *yPointer++;
		const Yep8u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V8uV8u_V16u_Default(const Yep8u* YEP_RESTRICT xPointer, const Yep8u* YEP_RESTRICT yPointer, Yep16u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep16u x = *xPointer++;
		const Yep16u y = *yPointer++;
		const Yep16u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V8sV8s_V16s_Default(const Yep8s* YEP_RESTRICT xPointer, const Yep8s* YEP_RESTRICT yPointer, Yep16s* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep16s x = *xPointer++;
		const Yep16s y = *yPointer++;
		const Yep16s product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V16uV16u_V16u_Default(const Yep16u* YEP_RESTRICT xPointer, const Yep16u* YEP_RESTRICT yPointer, Yep16u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep16u x = *xPointer++;
		const Yep16u y = *yPointer++;
		const Yep16u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V16uV16u_V32u_Default(const Yep16u* YEP_RESTRICT xPointer, const Yep16u* YEP_RESTRICT yPointer, Yep32u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep32u x = *xPointer++;
		const Yep32u y = *yPointer++;
		const Yep32u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V16sV16s_V32s_Default(const Yep16s* YEP_RESTRICT xPointer, const Yep16s* YEP_RESTRICT yPointer, Yep32s* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep32s x = *xPointer++;
		const Yep32s y = *yPointer++;
		const Yep32s product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V32uV32u_V32u_Default(const Yep32u* YEP_RESTRICT xPointer, const Yep32u* YEP_RESTRICT yPointer, Yep32u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep32u x = *xPointer++;
		const Yep32u y = *yPointer++;
		const Yep32u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V32uV32u_V64u_Default(const Yep32u* YEP_RESTRICT xPointer, const Yep32u* YEP_RESTRICT yPointer, Yep64u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep64u x = *xPointer++;
		const Yep64u y = *yPointer++;
		const Yep64u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V32sV32s_V64s_Default(const Yep32s* YEP_RESTRICT xPointer, const Yep32s* YEP_RESTRICT yPointer, Yep64s* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep64s x = *xPointer++;
		const Yep64s y = *yPointer++;
		const Yep64s product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V64uV64u_V64u_Default(const Yep64u* YEP_RESTRICT xPointer, const Yep64u* YEP_RESTRICT yPointer, Yep64u* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep64u x = *xPointer++;
		const Yep64u y = *yPointer++;
		const Yep64u product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V32fV32f_V32f_Default(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep32f x = *xPointer++;
		const Yep32f y = *yPointer++;
		const Yep32f product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_Multiply_V64fV64f_V64f_Default(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT productPointer, YepSize length) {
	while (length-- != 0) {
		const Yep64f x = *xPointer++;
		const Yep64f y = *yPointer++;
		const Yep64f product = x * y;
		*productPointer++ = product;
	}
	return YepStatusOk;
}
